<?php

namespace App\Http\Controllers;

use Exception;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class CostPerformanceController extends Controller
{
    //
    public function getCostPerformanceData()
    {
        try {
            $query = "SELECT  
            D.`Name` ,
            D.TotalBudjet ,
            IF(ISNULL(ROUND((D.BudjetForWorkDone/D.TotalBudjet)*100,2)),0,ROUND((D.BudjetForWorkDone/D.TotalBudjet)*100,2)) AS WorkDonePercentage , 
            D.BudjetForWorkDone ,
            D.ActualExpenditure , 
            D.BudjetForWorkDone - D.ActualExpenditure As SaveLost ,
            IF(ISNULL(ROUND(((D.BudjetForWorkDone - D.ActualExpenditure)/D.BudjetForWorkDone) * 100,2)),0,ROUND(((D.BudjetForWorkDone - D.ActualExpenditure)/D.BudjetForWorkDone) * 100,2)) AS SaveLostPercentage  ,  
            D.TotalBudjet-D.BudjetForWorkDone AS RemainBudjet
            
            FROM 
            (SELECT  
            JG2.`Name` , 
            ROUND(SUM(J.Budget)/1000000,2) AS TotalBudjet , 
            ROUND(SUM(J.Budget*(J.WorkDone/100))/1000000,2) AS BudjetForWorkDone , 
            IF(ISNULL(ROUND(SUM(JH.Actual)/1000000,2)),0,ROUND(SUM(JH.Actual)/1000000,2)) AS ActualExpenditure 
            
            FROM Job J 
            INNER JOIN JGroupL2 JG2  ON J.JobGroupIDL2 = JG2.GroupIDL2
            LEFT JOIN ( SELECT  JobID , SUM(Quantity*Amount) AS Actual  FROM   JobHistory WHERE TranDate<='2023-04-30' GROUP BY JobID  ) JH ON JH.JobID=J.JobID 
            
            GROUP BY J.JobGroupIDL2 ) D";

            $result = DB::select($query);

            return response()->json(['status' => true, 'data' => $result]);
        } catch (Exception $ex) {
            return response()->json(['status' => false, 'error' => $ex]);
        }
    }
}
