<?php

namespace App\Http\Controllers;

use Exception;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class SummaryController extends Controller
{

    public function getDonutData()
    {
        try {
            $query = "SELECT  
            ROUND(((D.TotalValue-D.ActualCost ) / D.TotalValue),2) * 100  AS budget ,
            ROUND((D.ActualCost  / D.TotalValue),2) * 100 AS expenditure,
            ROUND(((D.TotalValue-D.EarnValue ) / D.TotalValue),2) * 100  AS pending  ,
            ROUND((D.EarnValue  / D.TotalValue),2) * 100 AS workdone 
           
            
           FROM   
           
           (SELECT 
           (SELECT ROUND(SUM(Budget*(WorkDone/100)) /1000000,2)  FROM  Job   ) AS EarnValue , 
           (SELECT ROUND(SUM(Budget) /1000000,2)    FROM  Job   WHERE TargetDate <= '2023-04-30' ) AS PlannedValue ,
           (SELECT ROUND(SUM(Budget) /1000000,2)    FROM  Job   ) AS TotalValue ,
           (SELECT ROUND(SUM(JH.Amount*JH.Quantity)/1000000,2)    FROM  Job J 
           INNER JOIN JobHistory JH ON J.JobID=JH.JobID WHERE TranDate<='2023-04-30') AS ActualCost ) D";

            $result = DB::select($query);

            return response()->json(['status' => true, 'data' => $result]);
        } catch (Exception $ex) {
            return response()->json(['status' => false, 'error' => $ex]);
        }
    }



    public function getTaskData()
    {
        try {
            $query = "SELECT 'Total tasks'AS task,
            '3000' AS no_of_task";

            $result = DB::select($query);

            return response()->json(['status' => true, 'data' => $result]);
        } catch (Exception $ex) {
            return response()->json(['status' => false, 'error' => $ex]);
        }
    }


    public function getBarchartData()
    {
        try {
            $query = "SELECT t.YearLable ,
            t.MonthLable ,
            FORMAT((t.Expenditure/1000000),2) As Expenditure,
            FORMAT(((@running_total:=@running_total + t.Expenditure))/1000000,2) AS cumulative_sum,'0' AS Budget
     FROM 
     (SELECT  YEAR(JH.TranDate) AS YearLable ,  MONTHNAME(JH.TranDate) AS  MonthLable  ,  SUM(JH.Quantity*JH.Amount) AS Expenditure    FROM  JobHistory JH 
     INNER JOIN Job J ON  JH.JobID=J.JobID 
     WHERE JH.TranDate BETWEEN  DATE_SUB(CURDATE(),INTERVAL 6 Month) AND CURDATE()
     GROUP BY     YEAR(JH.TranDate) ,  MONTHNAME(JH.TranDate) ORDER BY JH.TranDate ) t 
     JOIN (SELECT @running_total:=0) r ";

            $result = DB::select($query);

            $xAxis = array();
            $BudgetList = array();
            $ExpenditureList = array();
            $CumExpenditureList = array();



            foreach ($result as $res) {
                array_push($xAxis, $res->YearLable);
                array_push($ExpenditureList, $res->Expenditure);
                array_push($BudgetList, $res->Budget);
                array_push($CumExpenditureList, $res->cumulative_sum);
            }

            $details = array([
                'xAxis' => $xAxis,
                'Budget' => $BudgetList,
                'Expenditure' => $ExpenditureList,
                'CumExpenditure' => $CumExpenditureList
            ]);

            return response()->json(['status' => true, 'data' => $details[0]]);
        } catch (Exception $ex) {
            return response()->json(['status' => false, 'error' => $ex]);
        }
    }
}
