$(document).ready(function () {
    getCostPerformanceData();
});


function getCostPerformanceData() {
    $.ajax({
        type: "GET",
        url: "/cost_performance/getCostPerformanceData",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.status) {
                $('#tblCostPerformance').empty();
                var total_budget_amount = 0;
                var budget_workdone_amount = 0;
                var budget_workdone_amount = 0;
                var actual_expenditure_amount = 0;
                var save_lost_amount = 0;
                var remined_budget_amount = 0;
                var total_workdone_percentage = 0;
                var total_save_lost_percentage = 0;
                for (var i = 0; i < response.data.length; i++) {

                    total_budget_amount += parseFloat(response.data[i].TotalBudjet);
                    budget_workdone_amount += parseFloat(response.data[i].BudjetForWorkDone);
                    actual_expenditure_amount += parseFloat(response.data[i].ActualExpenditure);
                    save_lost_amount += parseFloat(response.data[i].SaveLost);
                    remined_budget_amount += parseFloat(response.data[i].RemainBudjet);
                    total_workdone_percentage += (parseFloat(response.data[i].WorkDonePercentage) / 100.0);
                    total_save_lost_percentage += (parseFloat(response.data[i].SaveLostPercentage) / 100.0);
                    var row_class = 'class="even_row"';
                    if (i % 2 == 1) {
                        row_class = 'class="odd_row"';
                    }
                    var row_text_color = "black";
                    if (response.data[i].SaveLost < 0) {
                        row_text_color = "red";
                    }
                    var row = '<tr ' + row_class + '>';
                    row += '<td style="color:' + row_text_color + '">' + response.data[i].Name + '</td>';
                    row += '<td style="text-align:right;color:' + row_text_color + '">' + response.data[i].TotalBudjet.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2, }) + '</td>';
                    row += '<td><div class="progress"> <div class="progress-bar progress-bar-striped" role="progressbar" style="width: ' + response.data[i].WorkDonePercentage + '%" aria-valuenow="10" aria-valuemin="0" aria-valuemax="100 ">' + response.data[i].WorkDonePercentage + '% </div></div></td>';
                    row += '<td style="text-align:right;color:' + row_text_color + '">' + response.data[i].BudjetForWorkDone.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2, }) + '</td>';
                    row += '<td style="text-align:right;color:' + row_text_color + '">' + response.data[i].ActualExpenditure.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2, }) + '</td>';
                    row += '<td style="text-align:right;color:' + row_text_color + '">' + response.data[i].SaveLost.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2, }) + '</td>';
                    row += '<td><div class="progress"> <div class="progress-bar progress-bar-striped" role="progressbar" style="width: ' + response.data[i].SaveLostPercentage + '%" aria-valuenow="10" aria-valuemin="0" aria-valuemax="100">' + response.data[i].SaveLostPercentage + '%</div></div></td>';
                    row += '<td style="text-align:right;color:' + row_text_color + '">' + response.data[i].RemainBudjet.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2, }) + '</td>';
                    row += '</tr>';
                    $('#tblCostPerformance').append(row);
                }

                var row = '<tr ' + row_class + '>';
                row += '<td>Total</td>';
                row += '<td style="text-align:right;">' + total_budget_amount.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2, }) + '</td>';
                row += '<td><div class="progress"> <div class="progress-bar progress-bar-striped" role="progressbar" style="width: ' + total_workdone_percentage + '%" aria-valuenow="10" aria-valuemin="0" aria-valuemax="100">' + total_workdone_percentage + '% </div></div></td>';
                row += '<td style="text-align:right;">' + budget_workdone_amount.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2, }) + '</td>';
                row += '<td style="text-align:right;">' + actual_expenditure_amount.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2, }) + '</td>';
                row += '<td style="text-align:right;">' + save_lost_amount.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2, }) + '</td>';
                row += '<td><div class="progress"> <div class="progress-bar progress-bar-striped" role="progressbar" style="width: ' + total_save_lost_percentage + '%" aria-valuenow="10" aria-valuemin="0" aria-valuemax="100">' + total_save_lost_percentage + '% </div></div></td>';
                row += '<td style="text-align:right;">' + remined_budget_amount.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2, }) + '</td>';
                row += '</tr>';
                $('#tblCostPerformance').append(row);
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}