$(document).ready(function () {
    getFinanceChartData();
});


function getFinanceChartData() {
    $.ajax({
        type: "GET",
        url: "/finance/getFinanceChartData",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response.data);
            if (response.status) {
                initFinanceChart(response.data);
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}



function initFinanceChart(data) {
   

    /** Finance Chart */
    var costData1 = data;
    console.log(costData1);
    var ctx1 = document.getElementById('myChart6').getContext('2d');
    var myChart = new Chart(ctx1, {
        type: 'line',
        data: {
            labels: costData1.month,
            datasets: [
                {
                    label: 'Actual Expense',
                    data: costData1.actual,
                    showLine: true,
                    fill: false,
                    borderColor: 'rgb(255,0,0)',
                    // spanGaps: false,
                },
                {
                    label: 'Budget',
                    data: costData1.budget,
                    showLine: true,
                    fill: false,
                    borderColor: 'rgba(0, 200, 0, 1)',
                    // spanGaps: false,
                },
                {
                    label: 'Inflow',
                    data: costData1.inflow,
                    showLine: true,
                    fill: false,
                    borderColor: 'rgba(54, 162, 235, 1)'
                    // spanGaps: false,
                },
            ]
        },
        options: {
            elements: {
                line: {
                    tension: 0
                }
            },
            scales: {
                yAxes: [{
                    // stacked: true,
                    type: 'linear',
                    ticks: {
                        beginAtZero: true,
                    }
                }]
            },
            onClick: function (evt) {
                var element = myChart.getElementAtEvent(evt);
                if (element.length > 0) {
                    var ind = element[0]._index;
                    //   window.location = "viewgrn.php";
                }
            },
            spanGaps: true,
            legend: {
                onClick: function (event, elem) {
                    // console.log("legend click @ x: " + event.clientX + ", y:" + event.clientY);
                    // window.location = "grn.php";
                }
            },
            tooltips: {
                callbacks: {
                    label: function (tooltipItem, chart) {
                        var datasetLabel = chart.datasets[tooltipItem.datasetIndex].label || '';
                        return datasetLabel + ': Rs. ' + numberWithCommas(tooltipItem.yLabel);
                    }
                }
            }

        }
    });
    /** End Of Finance Chart */


}

