$(document).ready(function () {
    getStaffData();
    getManPowerData();
    getContractData();
});


function getStaffData() {
    $.ajax({
        type: "GET",
        url: "/resource/staffData",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.status) {
                $('#tblStaffResource').empty();
                var total = 0;

                for (var i = 0; i < response.data.length; i++) {

                    total += parseFloat(response.data[i].no_of_persion);
                    var row_class = 'class="even_row"';
                    if (i % 2 == 1) {
                        row_class = 'class="odd_row"';
                    }
                    var row = '<tr ' + row_class + '>';
                    row += '<td>' + response.data[i].Designation + '</td>';
                    row += '<td style="text-align:right;">' + response.data[i].no_of_persion+ '</td>';
                    row += '</tr>';
                    $('#tblStaffResource').append(row);
                }

                var row = '<tr ' + row_class + '>';
                row += '<td>Total</td>';
                row += '<td style="text-align:right;">' + total + '</td>';
                row += '</tr>';
                $('#tblStaffResource').append(row);
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}




function getManPowerData() {
    $.ajax({
        type: "GET",
        url: "/resource/manPowerData",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.status) {
                $('#tblManPowerResource').empty();
                var total = 0;

                for (var i = 0; i < response.data.length; i++) {

                    total += parseFloat(response.data[i].no_of_persion);
                    var row_class = 'class="even_row"';
                    if (i % 2 == 1) {
                        row_class = 'class="odd_row"';
                    }
                    var row = '<tr ' + row_class + '>';
                    row += '<td>' + response.data[i].Name + '</td>';
                    row += '<td style="text-align:right;">' + response.data[i].no_of_persion+ '</td>';
                    row += '</tr>';
                    $('#tblManPowerResource').append(row);
                }

                var row = '<tr ' + row_class + '>';
                row += '<td>Total</td>';
                row += '<td style="text-align:right;">' + total + '</td>';
                row += '</tr>';
                $('#tblManPowerResource').append(row);
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}




function getContractData() {
    $.ajax({
        type: "GET",
        url: "/resource/contractData",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.status) {
                $('#tblContractResource').empty();
                var total = 0;

                for (var i = 0; i < response.data.length; i++) {

                    total += parseFloat(response.data[i].no_of_persion);
                    var row_class = 'class="even_row"';
                    if (i % 2 == 1) {
                        row_class = 'class="odd_row"';
                    }
                    var row = '<tr ' + row_class + '>';
                    row += '<td>' + response.data[i].Name + '</td>';
                    row += '<td style="text-align:right;">' + response.data[i].no_of_persion+ '</td>';
                    row += '</tr>';
                    $('#tblContractResource').append(row);
                }

                var row = '<tr ' + row_class + '>';
                row += '<td>Total</td>';
                row += '<td style="text-align:right;">' + total + '</td>';
                row += '</tr>';
                $('#tblContractResource').append(row);
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}