$(document).ready(function () {
    getDonutData();
    getTaskData();
    getBarchartData();
});


function getDonutData() {
    $.ajax({
        type: "GET",
        url: "/summary/getDonutData",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.status) {
                //initBudgetDonut(response.data[0].budget, response.data[0].expenditure);
                initDonut(response.data[0].budget, response.data[0].expenditure, response.data[0].pending, response.data[0].workdone);
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}



function getBarchartData() {
    $.ajax({
        type: "GET",
        url: "/summary/getBarchartData",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.status) {
                //initBudgetDonut(response.data[0].budget, response.data[0].expenditure);
                initBarChart(response.data);
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}




function initPendingDonut(pending, workdone) {
    const ctx2 = document.getElementById('myChart2');

    new Chart(ctx2, {
        type: 'doughnut',
        data: {
            datasets: [{
                label: 'Percentage ',
                data: [pending, workdone],
                backgroundColor: [
                    'rgb(255,0,0)',
                    'rgb(0,0, 255)',
                ],
                hoverOffset: 4
            }],

            // These labels appear in the legend and in the tooltips when hovering different arcs
            labels: [
                'Pending',
                'Worke Done',

            ]
        },
        options: {
            scales: {
                y: {
                    beginAtZero: true
                }
            }
        }
    });

}




function initDonut(workdone_value, pending_value, budget_value, expenditure_value) {
    var Adapter_inner = [{ "label": "Pending", "Value": workdone_value }, { "label": "Work Done ", "Value": pending_value }];
    var Adapter_outter = [{ "label": "Remain Budget", "Value": budget_value }, { "label": "Expenditure", "Value": expenditure_value }];
    // prepare jqxChart settings
    var settings = {
        title: false,
        description: false,
        enableAnimations: true,
        showLegend: true,
        showBorderLine: false,
        legendLayout: { left: 450, top: 20, width: 400, height: 200, flow: 'horizontal' },
        padding: { left: 5, top: 2, right: 5, bottom: 2 },
        seriesGroups:
            [
                {
                    type: 'donut',
                    showLabels: false,
                    offsetX: 150,
                    offsetY: 150,
                    source: Adapter_outter,
                    colorScheme: 'scheme01',
                    xAxis:
                    {
                        // formatSettings: {prefix: 'Project '}
                    },
                    series:
                        [
                            {
                                dataField: 'Value',
                                displayText: 'label',
                                labelRadius: 170,
                                initialAngle: 90,
                                radius: 145,
                                innerRadius: 90,
                                centerOffset: 0,
                                formatSettings: { sufix: '%', decimalPlaces: 2 }
                            }
                        ]
                },
                {
                    type: 'donut',
                    showLabels: false,
                    offsetX: 150,
                    offsetY: 150,
                    source: Adapter_inner,
                    colorScheme: 'scheme05',
                    xAxis:
                    {
                        // formatSettings: {prefix: 'Claim '}
                    },
                    series:
                        [
                            {
                                dataField: 'Value',
                                displayText: 'label',
                                labelRadius: 120,
                                initialAngle: getAngle(Adapter_outter[0]['Value'], Adapter_inner[0]['Value']),
                                radius: 70,
                                innerRadius: 30,
                                centerOffset: 0,
                                formatSettings: { sufix: '%', decimalPlaces: 2 }
                            }
                        ]
                }
            ]
    };
    // setup the chart
    $('#chart2').jqxChart(settings);
}


function getAngle(d1, d2) {

    var d = (d1 - d2) * 2;
    return (d + 90);

}




function getTaskData() {
    $.ajax({
        type: "GET",
        url: "/summary/getTaskData",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.status) {
                //$('#tblProject').empty();
                for (var i = 0; i < response.data.length; i++) {
                    var row_class = 'class="even_row"';
                    if (i % 2 == 1) {
                        row_class = 'class="odd_row"';
                    }
                    var row = '<tr ' + row_class + '>';
                    row += '<td>' + response.data[i].task + '</td>';
                    row += '<td>' + response.data[i].no_of_task + '</td>';;
                    row += '</tr>';
                    //$('#tblTask').append(row);
                }
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}





function initSchedulePerformance(spi_value) {
    am5.ready(function () {

        // Create root element
        // https://www.amcharts.com/docs/v5/getting-started/#Root_element
        var root = am5.Root.new("chartdiv1");


        // Set themes
        // https://www.amcharts.com/docs/v5/concepts/themes/
        root.setThemes([
            am5themes_Animated.new(root)
        ]);


        // Create chart
        // https://www.amcharts.com/docs/v5/charts/radar-chart/
        var chart = root.container.children.push(am5radar.RadarChart.new(root, {
            panX: false,
            panY: false,
            startAngle: 180,
            endAngle: 360
        }));


        // Create axis and its renderer
        // https://www.amcharts.com/docs/v5/charts/radar-chart/gauge-charts/#Axes
        var axisRenderer = am5radar.AxisRendererCircular.new(root, {
            innerRadius: -40
        });



        axisRenderer.grid.template.setAll({
            stroke: root.interfaceColors.get("background"),
            visible: true,
            strokeOpacity: 0.8
        });

        var xAxis = chart.xAxes.push(am5xy.ValueAxis.new(root, {
            maxDeviation: 0,
            min: 0,
            max: 2,
            strictMinMax: true,
            renderer: axisRenderer
        }));





        // Add clock hand
        // https://www.amcharts.com/docs/v5/charts/radar-chart/gauge-charts/#Clock_hands
        var axisDataItem = xAxis.makeDataItem({});

        var clockHand = am5radar.ClockHand.new(root, {
            pinRadius: am5.percent(20),
            radius: am5.percent(100),
            bottomWidth: 40
        })

        var bullet = axisDataItem.set("bullet", am5xy.AxisBullet.new(root, {
            sprite: clockHand
        }));

        xAxis.createAxisRange(axisDataItem);

        var label = chart.radarContainer.children.push(am5.Label.new(root, {
            fill: am5.color(0xffffff),
            centerX: am5.percent(50),
            textAlign: "center",
            centerY: am5.percent(50),
            fontSize: "1em"
        }));

        axisDataItem.set("value", spi_value);
        bullet.get("sprite").on("rotation", function () {
            var value = spi_value;//axisDataItem.get("value");
            var text = Math.round(axisDataItem.get("value")).toString();
            var fill = am5.color(0x000000);
            xAxis.axisRanges.each(function (axisRange) {
                if (value >= axisRange.get("value") && value <= axisRange.get("endValue")) {
                    fill = "#0F1B97";
                }
            })

            label.set("text", value.toString());

            clockHand.pin.animate({ key: "fill", to: fill, duration: 500, easing: am5.ease.out(am5.ease.cubic) })
            clockHand.hand.animate({ key: "fill", to: fill, duration: 500, easing: am5.ease.out(am5.ease.cubic) })
        });

        /*setInterval(function () {
            axisDataItem.animate({
                key: "value",
                to: Math.round(Math.random() * 140 - 40),
                duration: 500,
                easing: am5.ease.out(am5.ease.cubic)
            });
        }, 100000000)*/

        chart.bulletsContainer.set("mask", undefined);


        var spi_val1 = 30;
        var spi_val2 = 200 - spi_val1;
        // Create axis ranges bands
        // https://www.amcharts.com/docs/v5/charts/radar-chart/gauge-charts/#Bands
        var bandsData = [{
            title: "Behind",
            color: "#FF0000",
            lowScore: 0,
            highScore: 1,
        }, {
            title: "Ahead",
            color: "#0f9747",
            lowScore: 1,
            highScore: 2
        }];

        am5.array.each(bandsData, function (data) {
            var axisRange = xAxis.createAxisRange(xAxis.makeDataItem({}));

            axisRange.setAll({
                value: data.lowScore,
                endValue: data.highScore
            });

            axisRange.get("axisFill").setAll({
                visible: true,
                fill: am5.color(data.color),
                fillOpacity: 0.8
            });

            axisRange.get("label").setAll({
                text: data.title,
                inside: true,
                radius: 15,
                fontSize: "0.9em",
                fill: root.interfaceColors.get("background")
            });
        });


        // Make stuff animate on load
        chart.appear(200, 200);

    }); // end am5.ready()
}




function initCostPerformance(cpi_value) {
    am5.ready(function () {

        // Create root element
        // https://www.amcharts.com/docs/v5/getting-started/#Root_element
        var root = am5.Root.new("chartdiv2");


        // Set themes
        // https://www.amcharts.com/docs/v5/concepts/themes/
        root.setThemes([
            am5themes_Animated.new(root)
        ]);


        // Create chart
        // https://www.amcharts.com/docs/v5/charts/radar-chart/
        var chart = root.container.children.push(am5radar.RadarChart.new(root, {
            panX: false,
            panY: false,
            startAngle: 180,
            endAngle: 360
        }));


        // Create axis and its renderer
        // https://www.amcharts.com/docs/v5/charts/radar-chart/gauge-charts/#Axes
        var axisRenderer = am5radar.AxisRendererCircular.new(root, {
            innerRadius: -40
        });

        axisRenderer.grid.template.setAll({
            stroke: root.interfaceColors.get("background"),
            visible: true,
            strokeOpacity: 0.8
        });

        var xAxis = chart.xAxes.push(am5xy.ValueAxis.new(root, {
            maxDeviation: 0,
            min: 0,
            max: 2,
            strictMinMax: true,
            renderer: axisRenderer
        }));


        // Add clock hand
        // https://www.amcharts.com/docs/v5/charts/radar-chart/gauge-charts/#Clock_hands
        var axisDataItem = xAxis.makeDataItem({});

        var clockHand = am5radar.ClockHand.new(root, {
            pinRadius: am5.percent(20),
            radius: am5.percent(100),
            bottomWidth: 40
        })

        var bullet = axisDataItem.set("bullet", am5xy.AxisBullet.new(root, {
            sprite: clockHand
        }));

        xAxis.createAxisRange(axisDataItem);

        var label = chart.radarContainer.children.push(am5.Label.new(root, {
            fill: am5.color(0xffffff),
            centerX: am5.percent(50),
            textAlign: "center",
            centerY: am5.percent(50),
            fontSize: "1em"
        }));

        axisDataItem.set("value", cpi_value);
        bullet.get("sprite").on("rotation", function () {
            var value = cpi_value;//axisDataItem.get("value");
            var text = Math.round(axisDataItem.get("value")).toString();
            var fill = am5.color(0x000000);
            xAxis.axisRanges.each(function (axisRange) {
                if (value >= axisRange.get("value") && value <= axisRange.get("endValue")) {
                    fill = "#0F1B97";
                }
            })

            label.set("text", value.toString());

            clockHand.pin.animate({ key: "fill", to: fill, duration: 500, easing: am5.ease.out(am5.ease.cubic) })
            clockHand.hand.animate({ key: "fill", to: fill, duration: 500, easing: am5.ease.out(am5.ease.cubic) })
        });

        /*setInterval(function () {
            axisDataItem.animate({
                key: "value",
                to: Math.round(Math.random() * 140 - 40),
                duration: 500,
                easing: am5.ease.out(am5.ease.cubic)
            });
        }, 100000000)*/

        chart.bulletsContainer.set("mask", undefined);



        // Create axis ranges bands
        // https://www.amcharts.com/docs/v5/charts/radar-chart/gauge-charts/#Bands
        var bandsData = [{
            title: "Over",
            color: "#FF0000",
            lowScore: 0,
            highScore: 1,
        }, {
            title: "Under",
            color: "#0f9747",
            lowScore: 1,
            highScore: 2
        }];

        am5.array.each(bandsData, function (data) {
            var axisRange = xAxis.createAxisRange(xAxis.makeDataItem({}));

            axisRange.setAll({
                value: data.lowScore,
                endValue: data.highScore
            });

            axisRange.get("axisFill").setAll({
                visible: true,
                fill: am5.color(data.color),
                fillOpacity: 0.8
            });

            axisRange.get("label").setAll({
                text: data.title,
                inside: true,
                radius: 15,
                fontSize: "0.9em",
                fill: root.interfaceColors.get("background")
            });
        });


        // Make stuff animate on load
        chart.appear(200, 200);

    }); // end am5.ready()
}



function initBarChart(Data) {
    //var Data = { "xAxis": ["May", "June", "July", "August", "September", "October", "November"], "Budget": ["46.28", "128.42", "158.22", "247.64", "74.73", "163.71", "207.72"], "Expenditure": ["40.47", "101.15", "82.49", "139.03", "64.90", "115.75", "128.48"], "CumExpenditure": ["40.47", "141.62", "224.11", "363.15", "428.04", "543.80", "672.27"] };
    var options = {
        series: [{
            name: 'Expenditure',
            type: 'column',
            data: Data.Expenditure
        }, {
            name: 'Budget',
            type: 'column',
            data: Data.Budget
        }, {
            name: 'Cum Expenditure',
            type: 'line',
            data: Data.CumExpenditure
        }],
        chart: {
            height: 300,
            width: "100%",
            type: 'line',
            stacked: false,
        },
        colors: ["#FF0000", "#0000FF", "#03FF02"],
        dataLabels: {
            enabled: false
        },
        stroke: {
            width: [1, 1, 4],
        },
        title: {
            text: 'Budget VS Expenditure (Million)',
            align: 'center',
            offsetX: 10,
            style: {
                fontSize: '9px'
            }
        },
        xaxis: {
            categories: Data.xAxis,
        },
        yaxis: [
            {
                seriesName: 'Expenditure',
                axisTicks: {
                    show: true,
                },
                axisBorder: {
                    show: true,
                    color: '#000000'
                },
                labels: {
                    style: {
                        colors: '#000000',
                    }
                },
                title: {
                    text: "Budget and expenditure (Million)",
                    style: {
                        color: '#000000',
                        fontSize: '12px',
                        fontWeight: 500,
                        fontFamily: 'Helvetica, Arial, sans-serif',
                    }
                },
                tooltip: {
                    enabled: true
                }
            },
            {
                seriesName: 'Expenditure',
                show: false
            },
            {
                seriesName: 'Cum Expenditure',
                opposite: true,
                axisTicks: {
                    show: true,
                },
                axisBorder: {
                    show: true,
                    color: '#000000'
                },
                labels: {
                    style: {
                        colors: '#000000',
                    }
                },
                title: {
                    text: "Cum Expenditure (Million)",
                    style: {
                        color: '#000000',
                        fontSize: '12px',
                        fontWeight: 500,
                        fontFamily: 'Helvetica, Arial, sans-serif',
                    }
                },
                tooltip: {
                    enabled: true
                }
            },
        ],
        tooltip: {
            enabled: true,
            theme: 'palette6',
            y: {
                formatter: function (value) {
                    return "Rs. " + numberWithCommas(value) + " million";
                }
            }
            // fixed: {
            //     enabled: true,
            //     position: 'topLeft', // topRight, topLeft, bottomRight, bottomLeft
            //     offsetY: 20,
            //     offsetX: 100
            // },
        },
        legend: {
            horizontalAlign: 'center',
            offsetX: 40,
        },
        markers: {
            size: 5,
            colors: '#FF0000',
            strokeColors: '#fff',
            strokeWidth: 2,
            strokeOpacity: 0.9,
            strokeDashArray: 0,
            fillOpacity: 1,
            shape: "circle",
            radius: 2,
            offsetX: 0,
            offsetY: 0,
            hover: {
                size: 8,
                sizeOffset: 3
            }
        }


    };

    var chart = new ApexCharts(document.querySelector("#chartdiv"), options);
    chart.render();

    // end chart
}










