<?php

use App\Http\Controllers\CostPerformanceController;
use App\Http\Controllers\FinanceController;
use App\Http\Controllers\ProjectController;
use App\Http\Controllers\ResourceController;
use App\Http\Controllers\SummaryController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/dashboard', function () {
    return view('dashboard');
});

Route::get('/', function () {
    return view('login');
});

Route::get('/project/getProjectData',[ProjectController::class,'getProjectData']);
Route::get('/summary/getDonutData',[SummaryController::class,'getDonutData']);
Route::get('/summary/getBarchartData',[SummaryController::class,'getBarchartData']);
Route::get('/summary/getTaskData',[SummaryController::class,'getTaskData']);
Route::get('/cost_performance/getCostPerformanceData',[CostPerformanceController::class,'getCostPerformanceData']);
Route::get('/resource/staffData',[ResourceController::class,'staffData']);
Route::get('/resource/manPowerData',[ResourceController::class,'manPowerData']);
Route::get('/resource/contractData',[ResourceController::class,'contractData']);
Route::get('/finance/getFinanceChartData',[FinanceController::class,'getFinanceChartData']);